-- VHDL Entity Board.FPGA_cursor.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:30 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY FPGA_cursor IS
    PORT( 
        button4_n  : IN     std_uLogic;
        clock      : IN     std_ulogic;
        encoderA_n : IN     std_uLogic;
        encoderB_n : IN     std_uLogic;
        encoderI_n : IN     std_uLogic;
        go1_n      : IN     std_uLogic;
        go2_n      : IN     std_uLogic;
        reset_n    : IN     std_ulogic;
        restart_n  : IN     std_uLogic;
        sensor1_n  : IN     std_uLogic;
        sensor2_n  : IN     std_uLogic;
        testMode   : IN     std_uLogic;
        LCD_A0     : OUT    std_ulogic;
        LCD_CS1_n  : OUT    std_ulogic;
        LCD_RST_n  : OUT    std_ulogic;
        LCD_SCL    : OUT    std_ulogic;
        LCD_SI     : OUT    std_ulogic;
        LED1       : OUT    std_uLogic;
        LED2       : OUT    std_ulogic;
        LEDs       : OUT    std_uLogic_vector (1 TO 8);
        motorOn    : OUT    std_uLogic;
        side1      : OUT    std_uLogic;
        side2      : OUT    std_uLogic
    );

-- Declarations

END FPGA_cursor ;





-- VHDL Entity Cursor.cursorCircuit.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY cursorCircuit IS
    GENERIC( 
        position0       : positive := 128;
        position1       : positive := 32000;
        position2       : positive := 64000;
        slopeShiftBitNb : positive := 6;
        pwmBitNb        : positive := 8;
        testLineNb      : positive := 16
    );
    PORT( 
        button4  : IN     std_uLogic;
        clock    : IN     std_ulogic;
        encoderA : IN     std_uLogic;
        encoderB : IN     std_uLogic;
        encoderI : IN     std_uLogic;
        go1      : IN     std_uLogic;
        go2      : IN     std_uLogic;
        reset    : IN     std_ulogic;
        restart  : IN     std_uLogic;
        sensor1  : IN     std_uLogic;
        sensor2  : IN     std_uLogic;
        testMode : IN     std_uLogic;
        A0       : OUT    std_ulogic;
        CS1_n    : OUT    std_ulogic;
        RST_n    : OUT    std_ulogic;
        SCL      : OUT    std_ulogic;
        SI       : OUT    std_ulogic;
        motorOn  : OUT    std_uLogic;
        side1    : OUT    std_uLogic;
        side2    : OUT    std_uLogic;
        testOut  : OUT    std_uLogic_vector (1 TO testLineNb)
    );

-- Declarations

END cursorCircuit ;





-- VHDL Entity Cursor.amplitudeControl.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY amplitudeControl IS
    GENERIC( 
        distanceBitNb : positive := 8;
        speedBitNb    : positive := 8;
        rampShift     : positive := 2
    );
    PORT( 
        amplitude  : OUT    unsigned (speedBitNb-1 DOWNTO 0);
        distance   : IN     signed (distanceBitNb-1 DOWNTO 0);
        fullSpeed  : IN     std_ulogic;
        zeroSpeed  : IN     std_ulogic;
        endReached : OUT    std_ulogic;
        reset      : IN     std_ulogic;
        clock      : IN     std_ulogic
    );

-- Declarations

END amplitudeControl ;





ARCHITECTURE RTL OF amplitudeControl IS

  signal amplitudeShifted: unsigned(amplitude'range);
  signal pathStarted: std_uLogic;

BEGIN
  ------------------------------------------------------------------------------
                                                -- shift amplitude for the slope
  amplitudeShifted <= resize(
    shift_right(unsigned(abs(distance)), rampShift),
    amplitude'length
  );

  ------------------------------------------------------------------------------
                                                                 -- select value
  selectValue: process(amplitudeShifted, fullSpeed, zeroSpeed)
  begin
    if zeroSpeed = '1' then
      amplitude <= (others => '0');
    elsif fullSpeed = '1' then
      amplitude <= (others => '1');
    else
      amplitude <= amplitudeShifted;
    end if;
  end process selectValue;

  ------------------------------------------------------------------------------
                                                           -- detect end of path
  endReached <= '1' when distance = 0
    else '0';

END ARCHITECTURE RTL;




-- VHDL Entity Cursor.bridgeControl.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY bridgeControl IS
    PORT( 
        PWM        : IN     std_ulogic;
        motorOn    : IN     std_ulogic;
        right_left : IN     std_ulogic;
        side1      : OUT    std_ulogic;
        side2      : OUT    std_ulogic
    );

-- Declarations

END bridgeControl ;





ARCHITECTURE RTL OF bridgeControl IS

BEGIN

  buildSideControls: process(right_left, PWM, motorOn)
  begin
    if right_left = '1' then
      side1 <= PWM and motorOn;
      side2 <= '0';
    else
      side2 <= PWM and motorOn;
      side1 <= '0';
    end if;
  end process buildSideControls;

END ARCHITECTURE RTL;




-- VHDL Entity Cursor.control.interface
--
-- Created:
--          by - francois.francois (Athena)
--          at - 17:37:29 12/12/17
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY control IS
    PORT( 
        button4        : IN     std_uLogic;
        clock          : IN     std_ulogic;
        endReached     : IN     std_ulogic;
        go1            : IN     std_uLogic;
        go2            : IN     std_uLogic;
        rampEnable     : IN     std_uLogic;
        reset          : IN     std_ulogic;
        restart        : IN     std_uLogic;
        sensor1        : IN     std_uLogic;
        sensor2        : IN     std_uLogic;
        clearPosition  : OUT    std_ulogic;
        fullSpeed      : OUT    std_ulogic;
        motorOn        : OUT    std_uLogic;
        right_left     : OUT    std_uLogic;
        selectPosition : OUT    unsigned (1 DOWNTO 0);
        stateOut       : OUT    std_uLogic_vector (1 TO 8);
        zeroSpeed      : OUT    std_ulogic
    );

-- Declarations

END control ;





--
-- VHDL Architecture Cursor.control.fsm
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:30 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
 
ARCHITECTURE fsm OF control IS

    TYPE STATE_TYPE IS (
        atPoint0,
        accelerate0To1,
        driveTo1,
        driveBack,
        decelerate0To1,
        accelerate0To2,
        drive1To2,
        decelerate1T02,
        accelerate2To1,
        drive2To1,
        decelerate2To1,
        accelerate1To2,
        atPoint1,
        atPoint2,
        unknownPos
    );
 
    -- State vector declaration
    ATTRIBUTE state_vector : string;
    ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state";

    -- Declare current and next state signals
    SIGNAL current_state : STATE_TYPE;
    SIGNAL next_state : STATE_TYPE;

BEGIN

    -----------------------------------------------------------------
    clocked_proc : PROCESS ( 
        clock,
        reset
    )
    -----------------------------------------------------------------
    BEGIN
        IF (reset = '1') THEN
            current_state <= unknownPos;
        ELSIF (clock'EVENT AND clock = '1') THEN
            current_state <= next_state;
        END IF;
    END PROCESS clocked_proc;
 
    -----------------------------------------------------------------
    nextstate_proc : PROCESS ( 
        current_state,
        endReached,
        go1,
        go2,
        rampEnable,
        restart,
        sensor1
    )
    -----------------------------------------------------------------
    BEGIN
        CASE current_state IS
            WHEN atPoint0 => 
                IF (go1 = '1') THEN 
                    next_state <= accelerate0To1;
                ELSIF (go2 = '1') THEN 
                    next_state <= accelerate0To2;
                ELSE
                    next_state <= atPoint0;
                END IF;
            WHEN accelerate0To1 => 
                IF (rampEnable = '0') THEN 
                    next_state <= driveTo1;
                ELSE
                    next_state <= accelerate0To1;
                END IF;
            WHEN driveTo1 => 
                IF (rampEnable = '1') THEN 
                    next_state <= decelerate0To1;
                ELSE
                    next_state <= driveTo1;
                END IF;
            WHEN driveBack => 
                IF (sensor1 = '1') THEN 
                    next_state <= atPoint0;
                ELSE
                    next_state <= driveBack;
                END IF;
            WHEN decelerate0To1 => 
                IF (endReached = '1') THEN 
                    next_state <= atPoint1;
                ELSE
                    next_state <= decelerate0To1;
                END IF;
            WHEN accelerate0To2 => 
                IF (rampEnable = '0') THEN 
                    next_state <= drive1To2;
                ELSE
                    next_state <= accelerate0To2;
                END IF;
            WHEN drive1To2 => 
                IF (rampEnable = '1') THEN 
                    next_state <= decelerate1T02;
                ELSE
                    next_state <= drive1To2;
                END IF;
            WHEN decelerate1T02 => 
                IF (endReached = '1') THEN 
                    next_state <= atPoint2;
                ELSE
                    next_state <= decelerate1T02;
                END IF;
            WHEN accelerate2To1 => 
                IF (rampEnable = '0') THEN 
                    next_state <= drive2To1;
                ELSE
                    next_state <= accelerate2To1;
                END IF;
            WHEN drive2To1 => 
                IF (rampEnable = '1') THEN 
                    next_state <= decelerate2To1;
                ELSE
                    next_state <= drive2To1;
                END IF;
            WHEN decelerate2To1 => 
                IF (endReached = '1') THEN 
                    next_state <= atPoint1;
                ELSE
                    next_state <= decelerate2To1;
                END IF;
            WHEN accelerate1To2 => 
                IF (rampEnable = '0') THEN 
                    next_state <= drive1To2;
                ELSE
                    next_state <= accelerate1To2;
                END IF;
            WHEN atPoint1 => 
                IF (go2 = '1') THEN 
                    next_state <= accelerate1To2;
                ELSIF (restart = '1') THEN 
                    next_state <= driveBack;
                ELSE
                    next_state <= atPoint1;
                END IF;
            WHEN atPoint2 => 
                IF (go1 = '1') THEN 
                    next_state <= accelerate2To1;
                ELSIF (restart = '1') THEN 
                    next_state <= driveBack;
                ELSE
                    next_state <= atPoint2;
                END IF;
            WHEN unknownPos => 
                IF (restart = '1') THEN 
                    next_state <= driveBack;
                ELSE
                    next_state <= unknownPos;
                END IF;
            WHEN OTHERS =>
                next_state <= unknownPos;
        END CASE;
    END PROCESS nextstate_proc;
 
    -----------------------------------------------------------------
    output_proc : PROCESS ( 
        current_state,
        sensor1
    )
    -----------------------------------------------------------------
    BEGIN
        -- Default Assignment
        clearPosition <= '0';
        fullSpeed <= '0';
        motorOn <= '-';
        right_left <= '-';
        selectPosition <= (others => '0');
        stateOut <= (others => '0');
        zeroSpeed <= '0';

        -- Combined Actions
        CASE current_state IS
            WHEN atPoint0 => 
                motorOn <= '0';
                zeroSpeed <= '1';
                stateOut(1) <= '1';
            WHEN accelerate0To1 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(0, selectPosition'length);
                stateOut(2) <= '1';
            WHEN driveTo1 => 
                motorOn <= '1';
                right_left <= '1';
                fullSpeed <= '1';
                selectPosition <= to_unsigned(1, selectPosition'length);
                stateOut(2 to 3) <= (others => '1');
            WHEN driveBack => 
                motorOn <= '1';
                right_left <= '0';
                selectPosition <= to_unsigned(0, selectPosition'length);
                fullSpeed <= '1';
                clearPosition <= sensor1;
                stateOut <= (others => '1');
            WHEN decelerate0To1 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(1, selectPosition'length);
                stateOut(3) <= '1';
            WHEN accelerate0To2 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(1, selectPosition'length);
                stateOut(5) <= '1';
            WHEN drive1To2 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(2, selectPosition'length);
                fullSpeed <= '1';
                stateOut(5 to 6) <= (others => '1');
            WHEN decelerate1T02 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(2, selectPosition'length);
                stateOut(6) <= '1';
            WHEN accelerate2To1 => 
                motorOn <= '1';
                right_left <= '0';
                selectPosition <= to_unsigned(2, selectPosition'length);
                stateOut(6) <= '1';
            WHEN drive2To1 => 
                motorOn <= '1';
                right_left <= '0';
                selectPosition <= to_unsigned(1, selectPosition'length);
                fullSpeed <= '1';
                stateOut(5 to 6) <= (others => '1');
            WHEN decelerate2To1 => 
                motorOn <= '1';
                right_left <= '0';
                selectPosition <= to_unsigned(1, selectPosition'length);
                stateOut(5) <= '1';
            WHEN accelerate1To2 => 
                motorOn <= '1';
                right_left <= '1';
                selectPosition <= to_unsigned(1, selectPosition'length);
                stateOut(5) <= '1';
            WHEN atPoint1 => 
                motorOn <= '0';
                zeroSpeed <= '1';
                stateOut(4) <= '1';
            WHEN atPoint2 => 
                motorOn <= '0';
                zeroSpeed <= '1';
                stateOut(7) <= '1';
            WHEN unknownPos => 
                motorOn <= '0';
                stateOut <= (others => '1');
            WHEN OTHERS =>
                NULL;
        END CASE;
    END PROCESS output_proc;
 
END fsm;




-- VHDL Entity Cursor.decelerationPositions.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY decelerationPositions IS
    GENERIC( 
        positionBitNb : positive := 16;
        distanceBitNb : positive := 10;
        position0     : positive := 128;
        position1     : positive := 32000;
        position2     : positive := 64000
    );
    PORT( 
        position       : IN     unsigned (positionBitNb-1 DOWNTO 0);
        selectPosition : IN     unsigned (1 DOWNTO 0);
        distance       : OUT    signed (distanceBitNb-1 DOWNTO 0);
        rampEnable     : OUT    std_uLogic
    );

-- Declarations

END decelerationPositions ;





ARCHITECTURE RTL OF decelerationPositions IS

  signal distanceToRefPoint : signed(position'high+1 downto 0);
  signal positionSigned : signed(position'high+1 downto 0);

BEGIN
  ------------------------------------------------------------------------------
                                                           -- calculate distance
  positionSigned <= signed(resize('0' & position, positionSigned'length));

  calculateDistance: process(selectPosition, positionSigned)
  begin
    case to_integer(selectPosition) is
      when 0 => distanceToRefPoint <= positionSigned - position0;
      when 1 => distanceToRefPoint <= positionSigned - position1;
      when 2 => distanceToRefPoint <= positionSigned - position2;
      when others => distanceToRefPoint <= (others => '-');
    end case;
  end process calculateDistance;

  distance <= resize(distanceToRefPoint, distance'length);

  ------------------------------------------------------------------------------
                                               -- check if ramp is to be enabled
  rampEnable <= '1' when abs(distanceToRefPoint) < 2**(distance'length-1)
    else '0';

END ARCHITECTURE RTL;




-- VHDL Entity Cursor.lcdDisplay.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:30 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY lcdDisplay IS
    GENERIC( 
        asciiBitNb : positive := 7
    );
    PORT( 
        reset : IN     std_ulogic;
        clock : IN     std_ulogic;
        ascii : OUT    std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
        send  : OUT    std_ulogic;
        busy  : IN     std_ulogic
    );

-- Declarations

END lcdDisplay ;





--
-- VHDL Architecture Cursor.lcdDisplay.fsm
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:30 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
 
ARCHITECTURE fsm OF lcdDisplay IS

    TYPE STATE_TYPE IS (
        init,
        home,
        H,
        e,
        l,
        l2,
        o,
        cr,
        lf,
        W,
        o2,
        r,
        l3,
        d,
        idle
    );
 
    -- Declare current and next state signals
    SIGNAL current_state : STATE_TYPE;
    SIGNAL next_state : STATE_TYPE;

BEGIN

    -----------------------------------------------------------------
    clocked_proc : PROCESS ( 
        clock,
        reset
    )
    -----------------------------------------------------------------
    BEGIN
        IF (reset = '1') THEN
            current_state <= init;
        ELSIF (clock'EVENT AND clock = '1') THEN
            current_state <= next_state;
        END IF;
    END PROCESS clocked_proc;
 
    -----------------------------------------------------------------
    nextstate_proc : PROCESS ( 
        busy,
        current_state
    )
    -----------------------------------------------------------------
    BEGIN
        CASE current_state IS
            WHEN init => 
                IF (busy = '0') THEN 
                    next_state <= home;
                ELSE
                    next_state <= init;
                END IF;
            WHEN home => 
                IF (busy = '0') THEN 
                    next_state <= H;
                ELSE
                    next_state <= home;
                END IF;
            WHEN H => 
                IF (busy = '0') THEN 
                    next_state <= e;
                ELSE
                    next_state <= H;
                END IF;
            WHEN e => 
                IF (busy = '0') THEN 
                    next_state <= l;
                ELSE
                    next_state <= e;
                END IF;
            WHEN l => 
                IF (busy = '0') THEN 
                    next_state <= l2;
                ELSE
                    next_state <= l;
                END IF;
            WHEN l2 => 
                IF (busy = '0') THEN 
                    next_state <= o;
                ELSE
                    next_state <= l2;
                END IF;
            WHEN o => 
                IF (busy = '0') THEN 
                    next_state <= cr;
                ELSE
                    next_state <= o;
                END IF;
            WHEN cr => 
                IF (busy = '0') THEN 
                    next_state <= lf;
                ELSE
                    next_state <= cr;
                END IF;
            WHEN lf => 
                IF (busy = '0') THEN 
                    next_state <= W;
                ELSE
                    next_state <= lf;
                END IF;
            WHEN W => 
                IF (busy = '0') THEN 
                    next_state <= o2;
                ELSE
                    next_state <= W;
                END IF;
            WHEN o2 => 
                IF (busy = '0') THEN 
                    next_state <= r;
                ELSE
                    next_state <= o2;
                END IF;
            WHEN r => 
                IF (busy = '0') THEN 
                    next_state <= l3;
                ELSE
                    next_state <= r;
                END IF;
            WHEN l3 => 
                IF (busy = '0') THEN 
                    next_state <= d;
                ELSE
                    next_state <= l3;
                END IF;
            WHEN d => 
                IF (busy = '0') THEN 
                    next_state <= idle;
                ELSE
                    next_state <= d;
                END IF;
            WHEN idle => 
                next_state <= idle;
            WHEN OTHERS =>
                next_state <= init;
        END CASE;
    END PROCESS nextstate_proc;
 
    -----------------------------------------------------------------
    output_proc : PROCESS ( 
        busy,
        current_state
    )
    -----------------------------------------------------------------
    BEGIN
        -- Default Assignment
        ascii <= (others => '0');
        send <= '0';

        -- Combined Actions
        CASE current_state IS
            WHEN init => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos(can), ascii'length));
                send  <= not busy;
            WHEN home => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos(stx), ascii'length));
                send  <= not busy;
            WHEN H => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('H'), ascii'length));
                send  <= not busy;
            WHEN e => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('e'), ascii'length));
                send  <= not busy;
            WHEN l => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('l'), ascii'length));
                send  <= not busy;
            WHEN l2 => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('l'), ascii'length));
                send  <= not busy;
            WHEN o => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('o'), ascii'length));
                send  <= not busy;
            WHEN cr => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos(cr), ascii'length));
                send  <= not busy;
            WHEN lf => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos(lf), ascii'length));
                send  <= not busy;
            WHEN W => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('W'), ascii'length));
                send  <= not busy;
            WHEN o2 => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('o'), ascii'length));
                send  <= not busy;
            WHEN r => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('r'), ascii'length));
                send  <= not busy;
            WHEN l3 => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('l'), ascii'length));
                send  <= not busy;
            WHEN d => 
                ascii <= std_ulogic_vector(to_unsigned(character'pos('d'), ascii'length));
                send  <= not busy;
            WHEN OTHERS =>
                NULL;
        END CASE;
    END PROCESS output_proc;
 
END fsm;




-- VHDL Entity LCD.lcdController.symbol
--
-- Created:
--          by - Administrators.UNKNOWN (WE5370)
--          at - 08:10:57 23.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2015.2 (Build 5)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY lcdController IS
  GENERIC( 
    baudRateDivide : integer  := 2;
    asciiBitNb     : positive := 7
  );
  PORT( 
    reset : IN     std_ulogic;
    SI    : OUT    std_ulogic;
    SCL   : OUT    std_ulogic;
    A0    : OUT    std_ulogic;
    CS1_n : OUT    std_ulogic;
    RST_n : OUT    std_ulogic;
    clock : IN     std_ulogic;
    ascii : IN     std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
    send  : IN     std_ulogic;
    busy  : OUT    std_ulogic
  );

-- Declarations

END lcdController ;





-- VHDL Entity LCD.lcdCharacterEncoder.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20114)
--          at - 16:12:51 09.01.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2015.2 (Build 5)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.ALL;

ENTITY lcdCharacterEncoder IS
  GENERIC( 
    asciiBitNb   : positive := 7;
    lcdDataBitNb : positive := 9;
    fontColumnNb : positive := 6;
    fontRowNb    : positive := 8;
    lcdPageNb    : positive := 4;
    lcdColumnNb  : positive := 132
  );
  PORT( 
    clock        : IN     std_ulogic;
    reset        : IN     std_ulogic;
    lcdData      : OUT    std_ulogic_vector (lcdDataBitNb-1 DOWNTO 0);
    asciiData    : IN     std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
    lcdBusy      : IN     std_ulogic;
    asciiBusy    : OUT    std_ulogic;
    asciiSend    : IN     std_ulogic;
    lcdSend      : OUT    std_ulogic;
    pixelData    : IN     std_ulogic_vector (fontColumnNb*fontRowNb-1 DOWNTO 0);
    clearDisplay : OUT    std_ulogic
  );

-- Declarations

END lcdCharacterEncoder ;





--------------------------------------------------------------------------------
-- Copyright 2012 HES-SO Valais Wallis (www.hevs.ch)
--------------------------------------------------------------------------------
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.
--
-- This program IS distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
-- You should have received a copy of the GNU General Public License along with
-- this program. If not, see <http://www.gnu.org/licenses/>
-- -----------------------------------------------------------------------------
-- Common Lib
--
-- -----------------------------------------------------------------------------
--  Authors:
--    cof: [Franois Corthay](francois.corthay@hevs.ch)
--    guo: [Oliver A. Gubler](oliver.gubler@hevs.ch)
-- -----------------------------------------------------------------------------
-- Changelog:
--   2016-06 : guo
--     added function sel
--   2015-06 : guo
--     added counterBitNb
--     added documentation
-- -----------------------------------------------------------------------------
library IEEE;
  use IEEE.std_logic_1164.all;
  use IEEE.numeric_std.all;

PACKAGE CommonLib IS

  ------------------------------------------------------------------------------
  -- Returns the number of bits needed to represent the given val
  -- Examples:
  --   requiredBitNb(1) = 1   (1)
  --   requiredBitNb(2) = 2   (10)
  --   requiredBitNb(3) = 2   (11)
  function requiredBitNb(val : integer) return integer;

  ------------------------------------------------------------------------------
  -- Returns the number of bits needed to count val times (0 to val-1)
  -- Examples:
  --   counterBitNb(1) = 1    (0)
  --   counterBitNb(2) = 1    (0->1)
  --   counterBitNb(3) = 2    (0->1->10)
  function counterBitNb(val : integer) return integer;

  ------------------------------------------------------------------------------
  -- Functions to return one or the other input based on a boolean.
  -- Can be used to build conditional constants.
  -- Example:
  --   constant bonjour_c : string := sel(ptpRole = master, "fpga20", "fpga02");
  function sel(Cond : BOOLEAN; If_True, If_False : integer)
                                            return integer;
  function sel(Cond : BOOLEAN; If_True, If_False : string)
                                            return string;
  function sel(Cond : BOOLEAN; If_True, If_False : std_ulogic_vector)
                                            return std_ulogic_vector;
  function sel(Cond : BOOLEAN; If_True, If_False : unsigned)
                                            return unsigned;
  function sel(Cond : BOOLEAN; If_True, If_False : signed)
                                            return signed;

END CommonLib;




--------------------------------------------------------------------------------
-- Copyright 2012 HES-SO Valais Wallis (www.hevs.ch)
--------------------------------------------------------------------------------
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 3 of the License, or
-- (at your option) any later version.
--
-- This program IS distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-- GNU General Public License for more details.
-- You should have received a copy of the GNU General Public License along with
-- this program. If not, see <http://www.gnu.org/licenses/>
-- -----------------------------------------------------------------------------
-- Often used functions
--
-- -----------------------------------------------------------------------------
--  Authors:
--    cof: [Franois Corthay](francois.corthay@hevs.ch)
--    guo: [Oliver A. Gubler](oliver.gubler@hevs.ch)
-- -----------------------------------------------------------------------------
-- Changelog:
--   2016-06 : guo
--     added function sel
--   2015-06 : guo
--     added counterBitNb
-- -----------------------------------------------------------------------------
PACKAGE BODY CommonLib IS

  function requiredBitNb (val : integer) return integer is
    variable powerOfTwo, bitNb : integer;
  begin
    powerOfTwo := 1;
    bitNb := 0;
    while powerOfTwo <= val loop
      powerOfTwo := 2 * powerOfTwo;
      bitNb := bitNb + 1;
    end loop;
    return bitNb;
  end requiredBitNb;

  function counterBitNb (val : integer) return integer is
    variable powerOfTwo, bitNb : integer;
  begin
    powerOfTwo := 1;
    bitNb := 0;
    while powerOfTwo < val loop
      powerOfTwo := 2 * powerOfTwo;
      bitNb := bitNb + 1;
    end loop;
    return bitNb;
  end counterBitNb;

  function sel(Cond : BOOLEAN; If_True, If_False : integer)
                                            return integer is
  begin
    if (Cond = TRUE) then
      return (If_True);
    else
      return (If_False);
    end if;
  end function sel;

  function sel(Cond : BOOLEAN; If_True, If_False : string)
                                            return string is
  begin
    if (Cond = TRUE) then
      return (If_True);
    else
      return (If_False);
    end if;
  end function sel;

  function sel(Cond : BOOLEAN; If_True, If_False : std_ulogic_vector)
                                            return std_ulogic_vector is
  begin
    if (Cond = TRUE) then
      return (If_True);
    else
      return (If_False);
    end if;
  end function sel;

  function sel(Cond : BOOLEAN; If_True, If_False : unsigned)
                                            return unsigned is
  begin
    if (Cond = TRUE) then
      return (If_True);
    else
      return (If_False);
    end if;
  end function sel;

  function sel(Cond : BOOLEAN; If_True, If_False : signed)
                                            return signed is
  begin
    if (Cond = TRUE) then
      return (If_True);
    else
      return (If_False);
    end if;
  end function sel;

END CommonLib;




-- library Common;
  use work.CommonLib.all;

ARCHITECTURE Encoder OF lcdCharacterEncoder IS

  constant lcdLineBitNb   : positive := 6;
  constant lcdPageBitNb   : positive := 4;
  constant lcdColumnBitNb : positive := 8;
  

  type fontDisplayStateType is (
    init, idle, readChar, displayColumns
  );
  signal fontDisplayState   : fontDisplayStateType;

  signal asciiColumnCounter : unsigned(requiredBitNb(fontColumnNb)-1 downto 0);
  signal pixelOffset        : unsigned(requiredBitNb(fontColumnNb*fontRowNb-1)-1 downto 0);
  
  signal pageCounter        : unsigned(requiredBitNb(lcdPageNb)-1 downto 0);
  signal columnCounter      : unsigned(requiredBitNb(lcdColumnNb)-1 downto 0);

  signal A0                 : std_ulogic;
  
  signal pixelPage 	  		: std_ulogic_vector(fontRowNb-1 downto 0);
  signal pixelColumnHigh 	: std_ulogic_vector(fontRowNb-1 downto 0);
  signal pixelColumnLow  	: std_ulogic_vector(fontRowNb-1 downto 0);
  
BEGIN
  ------------------------------------------------------------------------------
                                                                   -- diplay FSM
  fontDisplaySequencer: process(reset, clock)
  begin
    if reset = '1' then
      fontDisplayState <= init;
    elsif rising_edge(clock) then
      case fontDisplayState is
        when init =>
          if lcdBusy = '0' then
            fontDisplayState <= idle;
          end if;
        when idle =>
          if asciiSend = '1' then
            fontDisplayState <= readChar;
          end if;
        when readChar =>
          fontDisplayState <= displayColumns;
        when displayColumns =>
          if (asciiColumnCounter = 0) and (lcdBusy = '0') then
            fontDisplayState <= idle;
          end if;
      end case;
    end if;
  end process fontDisplaySequencer;

  asciiBusy <= '0' when fontDisplayState = idle
    else '1';
  
  a0_proc: process(reset ,clock)
  begin
    if reset = '1' then
      A0 <= '0';
    elsif rising_edge(clock) then
      if asciiSend = '1' then
        if unsigned(asciiData) < 32 then
          A0 <= '0';
        else
          A0 <= '1';
        end if;
      end if;
    end if;
  end process a0_proc;
  

  ------------------------------------------------------------------------------
                                                         -- ascii column counter
  asciiCountColums: process(reset, clock)
  begin
    if reset = '1' then
      asciiColumnCounter <= (others => '0');
    elsif rising_edge(clock) then
      if asciiColumnCounter = 0 then
        if (fontDisplayState = idle) and (asciiSend = '1') then
          asciiColumnCounter <= asciiColumnCounter + 1;
        end if;
      else
        if (fontDisplayState = displayColumns) and (lcdBusy = '0') then
          if asciiColumnCounter < fontColumnNb then
            asciiColumnCounter <= asciiColumnCounter + 1;
          else
            asciiColumnCounter <= (others => '0');
          end if;
        end if;
      end if;
    end if;
  end process asciiCountColums;
  ------------------------------------------------------------------------------
                                                         -- page, column counter
  counter: process(reset, clock)
  begin
    if reset = '1' then
      pageCounter   <= (others => '0');
      columnCounter <= (others => '0');
      clearDisplay  <= '0';
    elsif rising_edge(clock) then
      clearDisplay <= '0';
      if asciiSend = '1' then
        case to_integer(unsigned(asciiData)) is
          when 2 =>   -- Start of text (home)
            pageCounter   <= (others => '0');
            columnCounter <= (others => '0');
          when 3 =>   -- End of text (end)
            pageCounter   <= to_unsigned(lcdPageNb - 1,pageCounter'length);
            columnCounter <= to_unsigned(lcdColumnNb - fontColumnNb, columnCounter'length);
          when 8 =>    -- BS (backspace) (column back)
            if (columnCounter - fontColumnNb) < 0 then
              columnCounter <= (others => '0');
            else
              columnCounter <= columnCounter - fontColumnNb;
            end if;
          when 10 =>   -- LF (linefeed) (next line)
            if pageCounter = (lcdPageNb-1) then
              pageCounter   <= (others => '0');
            else
              pageCounter   <= pageCounter + 1;
            end if;
          when 11 =>   -- Vertical Tab (prev line)
            if pageCounter = 0 then
              pageCounter   <= to_unsigned(lcdPageNb - 1,pageCounter'length);
            else
              pageCounter   <= pageCounter - 1;
            end if;
          when 13 =>   -- CR (carriage return) (coloumn back)
            columnCounter <= (others => '0');
          when 24 =>   -- CAN (cancel) (clear display)
            clearDisplay <= '1';
          when others =>
            if asciiData >= x"20" then -- normal ascii char
              columnCounter <= columnCounter + fontColumnNb;
            end if;
        end case;
      end if;
    end if;
  end process counter;

  lcdSend <= '1' when
      (fontDisplayState = displayColumns) and
      (lcdBusy = '0') and
      (asciiColumnCounter > 0)
    else '0';
  ------------------------------------------------------------------------------
                                                                     -- Ram Data
  pixelOffset <= resize(resize(fontColumnNb-asciiColumnCounter, pixelOffset'length)*fontRowNb, pixelOffset'length)
    when asciiColumnCounter > 0 else (others => '0');
  pixelPage 	  <= pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset) + lcdPageBitNb) & std_ulogic_vector(resize(pageCounter,lcdPageBitNb));
  pixelColumnHigh <= pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset) + (lcdColumnBitNb/2)) & std_ulogic_vector(columnCounter(columnCounter'high downto (columnCounter'length/2)));
  pixelColumnLow  <= pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset) + (lcdColumnBitNb/2)) & std_ulogic_vector(columnCounter((columnCounter'length/2)-1 downto columnCounter'low));
  lcdData <= A0 & pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset)) when (A0 = '1')
        else A0 & pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset)) when (pixelOffset >= 40)
        else A0 & pixelPage 																	when (pixelOffset >= 32)
        else A0 & pixelColumnHigh 																when (pixelOffset >= 24)
        else A0 & pixelColumnLow 																when (pixelOffset >= 16)
        else A0 & pixelData(to_integer(pixelOffset)+fontRowNb-1 downto to_integer(pixelOffset));
  
END ARCHITECTURE Encoder;




-- VHDL Entity LCD.lcdInitializer.symbol
--
-- Created:
--          by - Administrators.UNKNOWN (WE5370)
--          at - 08:10:57 23.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2015.2 (Build 5)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.ALL;

ENTITY lcdInitializer IS
  GENERIC( 
    dataBitNb : positive := 8+1
  );
  PORT( 
    lcdData      : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    clock        : IN     std_ulogic;
    columnSend   : IN     std_ulogic;
    columnData   : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    lcdSend      : OUT    std_ulogic;
    lcdBusy      : IN     std_ulogic;
    reset        : IN     std_ulogic;
    columnBusy   : OUT    std_ulogic;
    clearDisplay : IN     std_ulogic
  );

-- Declarations

END lcdInitializer ;





-- library Common;
  use work.CommonLib.all;

ARCHITECTURE RTL OF lcdInitializer IS

  constant initializationSequenceLength: positive := 14;
  type initializationDataType is array (1 to initializationSequenceLength+1)
    of std_ulogic_vector(lcdData'range);
  constant initializationData: initializationDataType :=(
    '0' & X"40",    -- Display start line 0
    '0' & X"A1",    -- ADC reverse
    '0' & X"C0",    -- Normal COM0~COM31
    '0' & X"A6",    -- Display normal
    '0' & X"A2",    -- Set bias 1/9 (Duty 1/33)
    '0' & X"2F",    -- Booster, Regulator and Follower on
    '0' & X"F8",    -- Set internal Booster to 3x / 4x
    '0' & X"00",    -- 
    '0' & X"23",    -- Contrast set
    '0' & X"81",    -- 
    '0' & X"1F",    -- 
    '0' & X"AC",    -- No indicator
    '0' & X"00",    -- 
    '0' & X"AF",    -- Display on
    std_ulogic_vector(to_unsigned(0, lcdData'length))
  );

  constant clearDisplaySequenceLength : positive := 566;--(3+132)*4 + 3; -- (3 commands + 132 columns) * 4 pages + jump back to start
  constant clearDisplayDataLength     : positive := 6;
  type clearDisplayDataType is array (1 to clearDisplayDataLength+1)
    of std_ulogic_vector(lcdData'range);
  constant clearDisplayData: clearDisplayDataType :=(
                    --  ind  seq
    '0' & X"B0",    --  1    Page 0
    '0' & X"B1",    --  2    Page 1
    '0' & X"B2",    --  3    Page 2
    '0' & X"B3",    --  4    Page 3
    '0' & X"10",    --  5    Column MSB 0
    '0' & X"00",    --  6    Column LSB 0
    '1' & X"00"     --  7    Data "empty"
  );

  signal initSequenceCounter: unsigned(requiredBitNb(initializationSequenceLength+1)-1 downto 0);
  signal initSequenceDone: std_ulogic;
  signal clearSequenceCounter: unsigned(requiredBitNb(clearDisplaySequenceLength+1)-1 downto 0);
  signal clearSequenceDone: std_ulogic;

BEGIN
  ------------------------------------------------------------------------------
                                              -- initialization sequence counter
  buildInitSequence: process(reset, clock) 
  begin
    if reset='1' then
      initSequenceCounter <= to_unsigned(1, initSequenceCounter'length);
    elsif rising_edge(clock) then
      if lcdBusy = '0' then
        if initSequenceDone = '0' then
          initSequenceCounter <= initSequenceCounter + 1;
        end if;
      end if;
    end if;
  end process buildInitSequence;

  initSequenceDone <= '1' when initSequenceCounter > initializationSequenceLength
    else '0';

  ------------------------------------------------------------------------------
                                                       -- clear sequence counter
  buildClearSequence: process(reset, clock) 
  begin
    if reset='1' then
      clearSequenceCounter <= to_unsigned(clearDisplaySequenceLength+1, clearSequenceCounter'length);
    elsif rising_edge(clock) then
      if lcdBusy = '0' then
        if clearDisplay = '1' and initSequenceDone = '1' then
          clearSequenceCounter <= to_unsigned(1, clearSequenceCounter'length);
        elsif clearSequenceDone = '0' then
          clearSequenceCounter <= clearSequenceCounter + 1;
        end if;
      end if;
    end if;
  end process buildClearSequence;

  clearSequenceDone <= '1' when clearSequenceCounter > clearDisplaySequenceLength
    else '0';

  ------------------------------------------------------------------------------
                                                             -- data multiplexer
  lcdData <= columnData when (initSequenceDone = '1' and clearSequenceDone = '1')
    else initializationData(to_integer(initSequenceCounter)) when (initSequenceCounter > 0 and initSequenceDone = '0')
    else clearDisplayData(1) when (clearSequenceCounter = 1 or clearSequenceCounter = 564)
    else clearDisplayData(2) when (clearSequenceCounter = 137)
    else clearDisplayData(3) when (clearSequenceCounter = 273)
    else clearDisplayData(4) when (clearSequenceCounter = 409)
    else clearDisplayData(5) when (clearSequenceCounter = 2 or clearSequenceCounter = 138 or clearSequenceCounter = 274 or clearSequenceCounter = 410 or clearSequenceCounter = 565)
    else clearDisplayData(6) when (clearSequenceCounter = 3 or clearSequenceCounter = 139 or clearSequenceCounter = 275 or clearSequenceCounter = 411 or clearSequenceCounter = 566)
    else clearDisplayData(7);
    
lcdSend <= columnSend when initSequenceDone = '1' and clearSequenceDone = '1'
    else not lcdBusy when initSequenceCounter <= initializationSequenceLength
    else not lcdBusy when clearSequenceCounter <= clearDisplaySequenceLength
    else '0';
  columnBusy <= lcdBusy when initSequenceDone = '1' and clearSequenceDone = '1'
    else '1';

END ARCHITECTURE RTL;




-- VHDL Entity Memory.bramDualportWritefirst.symbol
--
-- Created:
--          by - Administrators.UNKNOWN (WE5370)
--          at - 16:01:15 18.06.2012
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2015.2 (Build 5)
--
LIBRARY ieee;
    USE ieee.std_logic_1164.all;
    USE ieee.numeric_std.all;

ENTITY bramDualportWritefirst IS
  GENERIC( 
    addressBitNb : positive := 8;
    dataBitNb    : positive := 8;
    initFile     : string   := "bramInit.txt"
  );
  PORT( 
    clockA   : IN     std_ulogic;
    enA      : IN     std_ulogic;
    writeEnA : IN     std_ulogic;
    addressA : IN     std_ulogic_vector (addressBitNb-1 DOWNTO 0);
    dataInA  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    dataOutA : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    clockB   : IN     std_ulogic;
    enB      : IN     std_ulogic;
    writeEnB : IN     std_ulogic;
    addressB : IN     std_ulogic_vector (addressBitNb-1 DOWNTO 0);
    dataInB  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    dataOutB : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0)
  );

-- Declarations

END bramDualportWritefirst ;





USE std.textio.all;

ARCHITECTURE bhv OF bramDualportWritefirst IS
  -- Define ramContent type
  type ramContentType is array(0 to (2**addressBitNb)-1) of bit_vector(dataBitNb-1 DOWNTO 0);

  -- Define function to create initvalue signal
  impure function ReadRamContentFromFile(ramContentFilenAme : in string) return ramContentType is
    FILE     ramContentFile     : text is in ramContentFilenAme;
    variable ramContentFileLine : line;
    variable ramContent         : ramContentType;
  begin
    for i in ramContentType'range loop
      readline(ramContentFile, ramContentFileLine);
      read(ramContentFileLine, ramContent(i));
    end loop;
    return ramContent;
  end function;

  -- Declare ramContent signal
  shared variable ramContent: ramContentType := ReadRamContentFromFile(initFile);

BEGIN
  -- Port A
  process(clockA)
  begin
    if clockA'event and clockA='1' then
      if enA = '1' then
        if writeEnA = '1' then
          dataOutA <= dataInA;
          ramContent(to_integer(unsigned(addressA))) := to_bitvector(dataInA,'0');
        else
          dataOutA <= to_stdulogicvector(ramContent(to_integer(unsigned(addressA))));
        end if;
      end if;
    end if;
  end process;

  -- Port B
  process(clockB)
  begin
    if clockB'event and clockB='1' then
      if enB = '1' then
        if writeEnB = '1' then
          ramContent(to_integer(unsigned(addressB))) := to_bitvector(dataInB,'0');
          dataOutB <= dataInB;
        else
          dataOutB <= to_stdulogicvector(ramContent(to_integer(unsigned(addressB))));
        end if;
      end if;
    end if;
  end process;

END ARCHITECTURE bhv;




-- VHDL Entity LCD.lcdSerializer.symbol
--
-- Created:
--          by - UNKNOWN.UNKNOWN (WE5370)
--          at - 11:02:07 06.08.2013
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2015.2 (Build 5)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.ALL;

ENTITY lcdSerializer IS
  GENERIC( 
    dataBitNb      : positive := 9;
    baudRateDivide : integer  := 2
  );
  PORT( 
    clock : IN     std_ulogic;
    reset : IN     std_ulogic;
    SI    : OUT    std_ulogic;
    SCL   : OUT    std_ulogic;
    A0    : OUT    std_ulogic;
    CS_n  : OUT    std_ulogic;
    RST_n : OUT    std_ulogic;
    data  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    send  : IN     std_ulogic;
    busy  : OUT    std_ulogic
  );

-- Declarations

END lcdSerializer ;





-- library Common;
  use work.CommonLib.all;

ARCHITECTURE RTL OF lcdSerializer IS

  ------------------------------------------------------------------------------
  -- The clock-pulse rate of the SCL line can be up to 20 MHz @3.3V
  --    The clock frequency is divided by generic value "baudRateDivide"
  --    The corresponding "sclEn" is further divided by 2 to generate SCL
  --
  signal sclCounter: unsigned(requiredBitNb(baudRateDivide-1)-1 downto 0);
	signal sclEn: std_ulogic;
	signal scl_int: std_ulogic;

  ------------------------------------------------------------------------------
  -- The minimal reset pulse width is 1 us
  --    "sclEn" at 40 MHz has to be divided by 40 to generate the 1 us delay
  --
	constant resetCount : natural := 40;
  signal resetCounter: unsigned(requiredBitNb(2*resetCount-1)-1 downto 0);
	signal resetDone: std_ulogic;


  ------------------------------------------------------------------------------
  -- Serial data bits have to be stable at the rising edge of SCL
  --    Data bits will be updated at the falling edge of SCL
  --
  -- Data in comprises 9 bits: A0 (as MSB) and 8 row pixels or command bits
  -- A0 selects between command data (A0 = 0) and pixel data (A0 = 1)
  --
	constant pixelsPerColumn : positive := data'length-1;
	signal dataSampled : std_ulogic_vector(data'range);
	signal chipSelect : std_ulogic;
	signal updateData: std_ulogic;
  signal dataCounter: unsigned(requiredBitNb(pixelsPerColumn+1)-1 downto 0);

BEGIN
  ------------------------------------------------------------------------------
                                                        -- clock divider for SCL
  divideClock: process(reset, clock) 
	begin
    if reset='1' then
			scl_int <= '0';
      sclCounter <= (others => '0');
    elsif rising_edge(clock) then
      if sclEn = '1' then
        sclCounter <= (others => '0');
				scl_int <= not scl_int;
      else
        sclCounter <= sclCounter + 1;
			end if;
    end if;
  end process divideClock;

  sclEn <= '1' when sclCounter = baudRateDivide-1
    else '0';

  ------------------------------------------------------------------------------
                                                                    -- LCD reset
	process(clock,reset)
		variable i : natural;
	begin
		if reset = '1' then
			resetCounter <= (others => '0');
		elsif rising_edge(clock) then
			if sclEn = '1' then
  			if resetDone = '0' then
  				resetCounter <= resetCounter + 1;
  			end if;
			end if;
		end if;
	end process;

  resetDone <= '1' when resetCounter >= 2*resetCount-1
    else '0';
  RST_n <= '1' when resetCounter >= resetCount-1
    else '0';

  ------------------------------------------------------------------------------
                                                            -- sample input data
  process (reset, clock)
  begin
    if reset = '1' then
      dataSampled <= (others => '0');
    elsif rising_edge(clock) then
      if send = '1' then
        dataSampled <= data;
      end if;
    end if;
	end process;

  ------------------------------------------------------------------------------
                                                                           -- A0
	A0 <= dataSampled(data'high);

  ------------------------------------------------------------------------------
                                                               -- serialize data
  updateData <= sclEn and scl_int;

  process (reset, clock)
  begin
    if reset = '1' then
      dataCounter <= (others => '0');
    elsif rising_edge(clock) then
      if resetDone = '1' then
        if dataCounter = 0 then
          if send = '1' then
            dataCounter <= to_unsigned(pixelsPerColumn+1, dataCounter'length);
          end if;
        else
          if updateData = '1' then
            dataCounter <= dataCounter - 1;
          end if;
        end if;
      end if;
    end if;
	end process;

  busy <= '1' when (resetDone = '0') or (dataCounter > 0)
    else '0';
	chipSelect <= '1' when (dataCounter > 0) and (dataCounter < pixelsPerColumn+1)
	  else '0';

	sampleData: process (reset, clock)
	begin
		if reset = '1' then
      CS_n <= '1';
      SCL  <= '1';
      SI   <= '1';
		elsif rising_edge(clock) then
			if chipSelect = '1' then
        CS_n <= '0';
        SCL <= scl_int or not(chipSelect);
				SI <= dataSampled(to_integer(dataCounter-1));
			else
        CS_n <= '1';
        SCL <= '1';
        SI <= '1';
			end if;
		end if;
	end process sampleData;

END ARCHITECTURE RTL;




--------------------------------------------------------------------------------
--
-- VHDL Architecture LCD.lcdController.struct
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WE5370)
--          at - 16:18:39 08.02.2018
--
--------------------------------------------------------------------------------
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.ALL;

-- LIBRARY LCD;
-- LIBRARY Memory;

ARCHITECTURE struct OF lcdController IS

  -- Architecture declarations
  constant fontColumnNb: positive := 6;
  constant fontRowNb: positive := 8;
  constant characterPixelNb: positive := fontColumnNb*fontRowNb;
  
  constant lcdDataBitNb: positive := 8+1;
  constant lcdPageNb: positive := 4;
  constant lcdColumnNb: positive := 132;

  -- Internal signal declarations
  SIGNAL lcdData      : std_ulogic_vector(9-1 DOWNTO 0);
  SIGNAL lcdSend      : std_ulogic;
  SIGNAL lcdBusy      : std_ulogic;
  SIGNAL lcdData1     : std_ulogic_vector(lcdDataBitNb-1 DOWNTO 0);
  SIGNAL lcdSend1     : std_ulogic;
  SIGNAL lcdBusy1     : std_ulogic;
  SIGNAL dataInA      : std_ulogic_vector(characterPixelNb-1 DOWNTO 0);
  SIGNAL addressB     : std_ulogic_vector(asciiBitNb-1 DOWNTO 0);
  SIGNAL dataInB      : std_ulogic_vector(characterPixelNb-1 DOWNTO 0);
  SIGNAL writeEnB     : std_ulogic;
  SIGNAL enB          : std_ulogic;
  SIGNAL clockB       : std_ulogic;
  SIGNAL enA          : std_ulogic;
  SIGNAL writeEnA     : std_ulogic;
  SIGNAL pixelData    : std_ulogic_vector(characterPixelNb-1 DOWNTO 0);
  SIGNAL clearDisplay : std_ulogic;


  -- Component Declarations
  COMPONENT lcdCharacterEncoder
  GENERIC (
    asciiBitNb   : positive := 7;
    lcdDataBitNb : positive := 9;
    fontColumnNb : positive := 6;
    fontRowNb    : positive := 8;
    lcdPageNb    : positive := 4;
    lcdColumnNb  : positive := 132
  );
  PORT (
    clock        : IN     std_ulogic ;
    reset        : IN     std_ulogic ;
    lcdData      : OUT    std_ulogic_vector (lcdDataBitNb-1 DOWNTO 0);
    asciiData    : IN     std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
    lcdBusy      : IN     std_ulogic ;
    asciiBusy    : OUT    std_ulogic ;
    asciiSend    : IN     std_ulogic ;
    lcdSend      : OUT    std_ulogic ;
    pixelData    : IN     std_ulogic_vector (fontColumnNb*fontRowNb-1 DOWNTO 0);
    clearDisplay : OUT    std_ulogic 
  );
  END COMPONENT;
  COMPONENT lcdInitializer
  GENERIC (
    dataBitNb : positive := 8+1
  );
  PORT (
    lcdData      : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    clock        : IN     std_ulogic ;
    columnSend   : IN     std_ulogic ;
    columnData   : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    lcdSend      : OUT    std_ulogic ;
    lcdBusy      : IN     std_ulogic ;
    reset        : IN     std_ulogic ;
    columnBusy   : OUT    std_ulogic ;
    clearDisplay : IN     std_ulogic 
  );
  END COMPONENT;
  COMPONENT lcdSerializer
  GENERIC (
    dataBitNb      : positive := 9;
    baudRateDivide : integer  := 2
  );
  PORT (
    clock : IN     std_ulogic ;
    reset : IN     std_ulogic ;
    SI    : OUT    std_ulogic ;
    SCL   : OUT    std_ulogic ;
    A0    : OUT    std_ulogic ;
    CS_n  : OUT    std_ulogic ;
    RST_n : OUT    std_ulogic ;
    data  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    send  : IN     std_ulogic ;
    busy  : OUT    std_ulogic 
  );
  END COMPONENT;
  COMPONENT bramDualportWritefirst
  GENERIC (
    addressBitNb : positive := 8;
    dataBitNb    : positive := 8;
    initFile     : string   := "bramInit.txt"
  );
  PORT (
    clockA   : IN     std_ulogic ;
    enA      : IN     std_ulogic ;
    writeEnA : IN     std_ulogic ;
    addressA : IN     std_ulogic_vector (addressBitNb-1 DOWNTO 0);
    dataInA  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    dataOutA : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    clockB   : IN     std_ulogic ;
    enB      : IN     std_ulogic ;
    writeEnB : IN     std_ulogic ;
    addressB : IN     std_ulogic_vector (addressBitNb-1 DOWNTO 0);
    dataInB  : IN     std_ulogic_vector (dataBitNb-1 DOWNTO 0);
    dataOutB : OUT    std_ulogic_vector (dataBitNb-1 DOWNTO 0)
  );
  END COMPONENT;

  -- Optional embedded configurations
  -- pragma synthesis_off
--   FOR ALL : bramDualportWritefirst USE ENTITY Memory.bramDualportWritefirst;
--   FOR ALL : lcdCharacterEncoder USE ENTITY LCD.lcdCharacterEncoder;
--   FOR ALL : lcdInitializer USE ENTITY LCD.lcdInitializer;
--   FOR ALL : lcdSerializer USE ENTITY LCD.lcdSerializer;
  -- pragma synthesis_on


BEGIN
  -- Architecture concurrent statements
  -- HDL Embedded Text Block 1 eb1
  addressB <= (others => '0');
  dataInA <= (others => '0');
  dataInB <= (others => '0');
  enA <= '1';
  enB <= '0';
  writeEnA <= '0';
  writeEnB <= '0';
  clockB <= '0';
  


  -- Instance port mappings.
  I_font : lcdCharacterEncoder
    GENERIC MAP (
      asciiBitNb   => asciiBitNb,
      lcdDataBitNb => lcdDataBitNb,
      fontColumnNb => fontColumnNb,
      fontRowNb    => fontRowNb,
      lcdPageNb    => lcdPageNb,
      lcdColumnNb  => lcdColumnNb
    )
    PORT MAP (
      clock        => clock,
      reset        => reset,
      lcdData      => lcdData1,
      asciiData    => ascii,
      lcdBusy      => lcdBusy1,
      asciiBusy    => busy,
      asciiSend    => send,
      lcdSend      => lcdSend1,
      pixelData    => pixelData,
      clearDisplay => clearDisplay
    );
  I_init : lcdInitializer
    GENERIC MAP (
      dataBitNb => lcdDataBitNb
    )
    PORT MAP (
      lcdData      => lcdData,
      clock        => clock,
      columnSend   => lcdSend1,
      columnData   => lcdData1,
      lcdSend      => lcdSend,
      lcdBusy      => lcdBusy,
      reset        => reset,
      columnBusy   => lcdBusy1,
      clearDisplay => clearDisplay
    );
  I_ser : lcdSerializer
    GENERIC MAP (
      dataBitNb      => lcdDataBitNb,
      baudRateDivide => baudRateDivide
    )
    PORT MAP (
      clock => clock,
      reset => reset,
      SI    => SI,
      SCL   => SCL,
      A0    => A0,
      CS_n  => CS1_n,
      RST_n => RST_n,
      data  => lcdData,
      send  => lcdSend,
      busy  => lcdBusy
    );
  I_rom : bramDualportWritefirst
    GENERIC MAP (
      addressBitNb => asciiBitNb,
      dataBitNb    => characterPixelNb,
      initFile     => "C:/Users/oliver.gubler/eda/VHDL/labs/ELN_cursor/Simulation/font.txt"
    )
    PORT MAP (
      clockA   => clock,
      enA      => send,
      writeEnA => writeEnA,
      addressA => ascii,
      dataInA  => dataInA,
      dataOutA => pixelData,
      clockB   => clockB,
      enB      => enB,
      writeEnB => writeEnB,
      addressB => addressB,
      dataInB  => dataInB,
      dataOutB => OPEN
    );

END struct;




-- VHDL Entity Cursor.positionCounter.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY positionCounter IS
    GENERIC( 
        positionBitNb : positive := 16;
        position0     : positive := 128
    );
    PORT( 
        clock         : IN     std_ulogic;
        encoderA      : IN     std_ulogic;
        reset         : IN     std_ulogic;
        position      : OUT    unsigned (positionBitNb-1 DOWNTO 0);
        encoderB      : IN     std_ulogic;
        clearPosition : IN     std_ulogic;
        encoderI      : IN     std_ulogic
    );

-- Declarations

END positionCounter ;





ARCHITECTURE RTL OF positionCounter IS

  signal delayedA, risingA, fallingA: std_uLogic;
  signal delayedB, risingB, fallingB: std_uLogic;
  signal countEn, countInc: std_uLogic;
  signal positionCounter: unsigned(position'length-1 downto 0);

BEGIN
  ------------------------------------------------------------------------------
                                                                 -- signal edges
  delay: process(reset, clock)
  begin
    if reset = '1' then
      delayedA <= '0';
      delayedB <= '0';
    elsif rising_edge(clock) then
      delayedA <= encoderA;
      delayedB <= encoderB;
    end if;
  end process delay;

  risingA <= '1' when (encoderA = '1') and (delayedA = '0') else '0';
  fallingA <= '1' when (encoderA = '0') and (delayedA = '1') else '0';
  risingB <= '1' when (encoderB = '1') and (delayedB = '0') else '0';
  fallingB <= '1' when (encoderB = '0') and (delayedB = '1') else '0';

  ------------------------------------------------------------------------------
                                                              -- counter control
  countEn <= risingA or fallingA or risingB or fallingB;

  selectDirection: process(risingA, fallingA, risingB, fallingB, encoderA, encoderB)
  begin
    countInc <= '0';
    if risingA = '1' then
      if encoderB = '1' then
        countInc <= '1';
      end if;
    elsif fallingB = '1' then
      if encoderA = '1' then
        countInc <= '1';
      end if;
    elsif fallingA = '1' then
      if encoderB = '0' then
        countInc <= '1';
      end if;
    elsif risingB = '1' then
      if encoderA = '0' then
        countInc <= '1';
      end if;
    end if;
  end process selectDirection;

  ------------------------------------------------------------------------------
                                                                     -- counters
  countPosition: process(reset, clock)
  begin
    if reset = '1' then
      positionCounter <= (others => '0');
    elsif rising_edge(clock) then
      if clearPosition = '1' then
        positionCounter <= to_unsigned(position0, positionCounter'length);
      elsif countEn = '1' then
        if countInc = '1' then
          positionCounter <= positionCounter + 1;
        elsif positionCounter > 0 then
          positionCounter <= positionCounter - 1;
        end if;
      end if;
    end if;
  end process countPosition;

  position <= positionCounter;

END ARCHITECTURE RTL;




-- VHDL Entity Cursor.pulseWidthModulator.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY pulseWidthModulator IS
    GENERIC( 
        counterBitNb : positive := 8;
        minAmplitude : positive := 48
    );
    PORT( 
        amplitude : IN     unsigned (counterBitNb-1 DOWNTO 0);
        clock     : IN     std_ulogic;
        en        : IN     std_ulogic;
        reset     : IN     std_ulogic;
        PWM       : OUT    std_ulogic
    );

-- Declarations

END pulseWidthModulator ;





ARCHITECTURE RTL OF pulseWidthModulator IS

  signal amplitudeInt: unsigned(amplitude'range);
  signal counter: unsigned(counterBitNb-1 downto 0);

BEGIN
  ------------------------------------------------------------------------------
                                              -- grow amplitude to minimal value
  setMinimal: process(amplitude)
  begin
    if amplitude < minAmplitude then
      amplitudeInt <= to_unsigned(minAmplitude, amplitudeInt'length);
    else
      amplitudeInt <= amplitude;
    end if;
  end process setMinimal;

  ------------------------------------------------------------------------------
                                                         -- PWM sawtooth counter
  count: process(reset, clock)
  begin
    if reset = '1' then
      counter <= (others => '0');
    elsif rising_edge(clock) then
      if en = '1' then
        counter <= counter + 1;
      end if;
    end if;
  end process count;

  ------------------------------------------------------------------------------
                                                               -- PWM comparison
  buildPWM: process(amplitudeInt, counter)
  begin
    if amplitudeInt >= counter then
      PWM <= '1';
    else
      PWM <= '0';
    end if;
  end process buildPWM;

END ARCHITECTURE RTL;




-- VHDL Entity Cursor.divider.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:31 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

ENTITY divider IS
    PORT( 
        clock    : IN     std_ulogic;
        reset    : IN     std_ulogic;
        testMode : IN     std_uLogic;
        blink    : OUT    std_uLogic;
        enPWM    : OUT    std_uLogic
    );

-- Declarations

END divider ;





ARCHITECTURE RTL OF divider IS

  signal divideCounter: unsigned(1 downto 0);
  signal enPwmInt: std_uLogic;

  signal blinkCounter: unsigned(23 downto 0);

BEGIN
  ------------------------------------------------------------------------------
                                 -- Divide the clock frequency
                                 -- such as the PWM period is smaller as 100 kHz
  countPWM: process(reset, clock)
  begin
    if reset = '1' then
      divideCounter <= (others => '0');
    elsif rising_edge(clock) then
      divideCounter <= divideCounter + 1;
    end if;
  end process countPWM;

  buildEnPWM: process(divideCounter, testMode)
  begin
    enPwmInt <= '0';
    if testMode = '0' then
      if divideCounter = 0 then
        enPwmInt <= '1';
      end if;
    else
      enPwmInt <= '1';
    end if;
  end process buildEnPWM;

  enPWM <= enPwmInt;

  ------------------------------------------------------------------------------
                                                       -- Divide to approx. 1 Hz
  countBlink: process(reset, clock)
  begin
    if reset = '1' then
      blinkCounter <= (others => '0');
    elsif rising_edge(clock) then
      if enPwmInt = '1' then
        blinkCounter <= blinkCounter + 1;
      end if;
    end if;
  end process countBlink;

  blink <= blinkCounter(blinkCounter'high) when testMode = '0'
    else blinkCounter(4);

END ARCHITECTURE RTL;




--
-- VHDL Architecture Cursor.cursorCircuit.struct
--
-- Created:
--          by - francois.francois (Apheleia)
--          at - 18:24:39 11/09/18
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;

-- LIBRARY Cursor;
-- LIBRARY LCD;

ARCHITECTURE struct OF cursorCircuit IS

    -- Architecture declarations
    constant positionBitNb: positive := 18;
    constant relativePositionBitNb: positive := pwmBitNb + slopeShiftBitNb + 1;
    constant minAmplitude: positive := integer(0.25 * 2.0**pwmBitNb);
    constant lcdAsciiBitNb: positive := 7;

    -- Internal signal declarations
    SIGNAL PWM            : std_ulogic;
    SIGNAL amplitude      : unsigned(pwmBitNb-1 DOWNTO 0);
    SIGNAL blink          : std_uLogic;
    SIGNAL busy           : std_ulogic;
    SIGNAL character      : std_ulogic_vector(lcdAsciiBitNb-1 DOWNTO 0);
    SIGNAL clearPosition  : std_ulogic;
    SIGNAL distance       : signed(relativePositionBitNb-1 DOWNTO 0);
    SIGNAL enPWM          : std_uLogic;
    SIGNAL endReached     : std_ulogic;
    SIGNAL fullSpeed      : std_ulogic;
    SIGNAL position       : unsigned(positionBitNb-1 DOWNTO 0);
    SIGNAL rampEnable     : std_uLogic;
    SIGNAL right_left     : std_uLogic;
    SIGNAL selectPosition : unsigned(1 DOWNTO 0);
    SIGNAL send           : std_ulogic;
    SIGNAL stateOut       : std_uLogic_vector(1 TO 8);
    SIGNAL zeroSpeed      : std_ulogic;

    -- Implicit buffer signal declarations
    SIGNAL motorOn_internal : std_uLogic;


    -- Component Declarations
    COMPONENT amplitudeControl
    GENERIC (
        distanceBitNb : positive := 8;
        speedBitNb    : positive := 8;
        rampShift     : positive := 2
    );
    PORT (
        amplitude  : OUT    unsigned (speedBitNb-1 DOWNTO 0);
        distance   : IN     signed (distanceBitNb-1 DOWNTO 0);
        fullSpeed  : IN     std_ulogic ;
        zeroSpeed  : IN     std_ulogic ;
        endReached : OUT    std_ulogic ;
        reset      : IN     std_ulogic ;
        clock      : IN     std_ulogic 
    );
    END COMPONENT;
    COMPONENT bridgeControl
    PORT (
        PWM        : IN     std_ulogic ;
        motorOn    : IN     std_ulogic ;
        right_left : IN     std_ulogic ;
        side1      : OUT    std_ulogic ;
        side2      : OUT    std_ulogic 
    );
    END COMPONENT;
    COMPONENT control
    PORT (
        button4        : IN     std_uLogic ;
        clock          : IN     std_ulogic ;
        endReached     : IN     std_ulogic ;
        go1            : IN     std_uLogic ;
        go2            : IN     std_uLogic ;
        rampEnable     : IN     std_uLogic ;
        reset          : IN     std_ulogic ;
        restart        : IN     std_uLogic ;
        sensor1        : IN     std_uLogic ;
        sensor2        : IN     std_uLogic ;
        clearPosition  : OUT    std_ulogic ;
        fullSpeed      : OUT    std_ulogic ;
        motorOn        : OUT    std_uLogic ;
        right_left     : OUT    std_uLogic ;
        selectPosition : OUT    unsigned (1 DOWNTO 0);
        stateOut       : OUT    std_uLogic_vector (1 TO 8);
        zeroSpeed      : OUT    std_ulogic 
    );
    END COMPONENT;
    COMPONENT decelerationPositions
    GENERIC (
        positionBitNb : positive := 16;
        distanceBitNb : positive := 10;
        position0     : positive := 128;
        position1     : positive := 32000;
        position2     : positive := 64000
    );
    PORT (
        position       : IN     unsigned (positionBitNb-1 DOWNTO 0);
        selectPosition : IN     unsigned (1 DOWNTO 0);
        distance       : OUT    signed (distanceBitNb-1 DOWNTO 0);
        rampEnable     : OUT    std_uLogic 
    );
    END COMPONENT;
    COMPONENT divider
    PORT (
        clock    : IN     std_ulogic ;
        reset    : IN     std_ulogic ;
        testMode : IN     std_uLogic ;
        blink    : OUT    std_uLogic ;
        enPWM    : OUT    std_uLogic 
    );
    END COMPONENT;
    COMPONENT lcdDisplay
    GENERIC (
        asciiBitNb : positive := 7
    );
    PORT (
        reset : IN     std_ulogic ;
        clock : IN     std_ulogic ;
        ascii : OUT    std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
        send  : OUT    std_ulogic ;
        busy  : IN     std_ulogic 
    );
    END COMPONENT;
    COMPONENT positionCounter
    GENERIC (
        positionBitNb : positive := 16;
        position0     : positive := 128
    );
    PORT (
        clock         : IN     std_ulogic ;
        encoderA      : IN     std_ulogic ;
        reset         : IN     std_ulogic ;
        position      : OUT    unsigned (positionBitNb-1 DOWNTO 0);
        encoderB      : IN     std_ulogic ;
        clearPosition : IN     std_ulogic ;
        encoderI      : IN     std_ulogic 
    );
    END COMPONENT;
    COMPONENT pulseWidthModulator
    GENERIC (
        counterBitNb : positive := 8;
        minAmplitude : positive := 48
    );
    PORT (
        amplitude : IN     unsigned (counterBitNb-1 DOWNTO 0);
        clock     : IN     std_ulogic ;
        en        : IN     std_ulogic ;
        reset     : IN     std_ulogic ;
        PWM       : OUT    std_ulogic 
    );
    END COMPONENT;
    COMPONENT lcdController
    GENERIC (
        baudRateDivide : integer  := 2;
        asciiBitNb     : positive := 7
    );
    PORT (
        reset : IN     std_ulogic ;
        SI    : OUT    std_ulogic ;
        SCL   : OUT    std_ulogic ;
        A0    : OUT    std_ulogic ;
        CS1_n : OUT    std_ulogic ;
        RST_n : OUT    std_ulogic ;
        clock : IN     std_ulogic ;
        ascii : IN     std_ulogic_vector (asciiBitNb-1 DOWNTO 0);
        send  : IN     std_ulogic ;
        busy  : OUT    std_ulogic 
    );
    END COMPONENT;

    -- Optional embedded configurations
    -- pragma synthesis_off
--     FOR ALL : amplitudeControl USE ENTITY Cursor.amplitudeControl;
--     FOR ALL : bridgeControl USE ENTITY Cursor.bridgeControl;
--     FOR ALL : control USE ENTITY Cursor.control;
--     FOR ALL : decelerationPositions USE ENTITY Cursor.decelerationPositions;
--     FOR ALL : divider USE ENTITY Cursor.divider;
--     FOR ALL : lcdController USE ENTITY LCD.lcdController;
--     FOR ALL : lcdDisplay USE ENTITY Cursor.lcdDisplay;
--     FOR ALL : positionCounter USE ENTITY Cursor.positionCounter;
--     FOR ALL : pulseWidthModulator USE ENTITY Cursor.pulseWidthModulator;
    -- pragma synthesis_on


BEGIN
    -- Architecture concurrent statements
    -- HDL Embedded Text Block 1 eb1
    testOut(1 to 7) <= stateOut(1 to 7);
    testOut(8) <= PWM;
    testOut(15) <= PWM;
    testOut(16) <= blink;


    -- Instance port mappings.
    I_ampl : amplitudeControl
        GENERIC MAP (
            distanceBitNb => relativePositionBitNb,
            speedBitNb    => pwmBitNb,
            rampShift     => slopeShiftBitNb
        )
        PORT MAP (
            amplitude  => amplitude,
            distance   => distance,
            fullSpeed  => fullSpeed,
            zeroSpeed  => zeroSpeed,
            endReached => endReached,
            reset      => reset,
            clock      => clock
        );
    I_bridge : bridgeControl
        PORT MAP (
            PWM        => PWM,
            motorOn    => motorOn_internal,
            right_left => right_left,
            side1      => side2,
            side2      => side1
        );
    I_ctrl : control
        PORT MAP (
            button4        => button4,
            clock          => clock,
            endReached     => endReached,
            go1            => go1,
            go2            => go2,
            rampEnable     => rampEnable,
            reset          => reset,
            restart        => restart,
            sensor1        => sensor1,
            sensor2        => sensor2,
            clearPosition  => clearPosition,
            fullSpeed      => fullSpeed,
            motorOn        => motorOn_internal,
            right_left     => right_left,
            selectPosition => selectPosition,
            stateOut       => stateOut,
            zeroSpeed      => zeroSpeed
        );
    I_dist : decelerationPositions
        GENERIC MAP (
            positionBitNb => positionBitNb,
            distanceBitNb => relativePositionBitNb,
            position0     => position0,
            position1     => position1,
            position2     => position2
        )
        PORT MAP (
            position       => position,
            selectPosition => selectPosition,
            distance       => distance,
            rampEnable     => rampEnable
        );
    I_tim : divider
        PORT MAP (
            clock    => clock,
            reset    => reset,
            testMode => testMode,
            blink    => blink,
            enPWM    => enPWM
        );
    I_lcd1 : lcdDisplay
        GENERIC MAP (
            asciiBitNb => lcdAsciiBitNb
        )
        PORT MAP (
            reset => reset,
            clock => clock,
            ascii => character,
            send  => send,
            busy  => busy
        );
    I_pos : positionCounter
        GENERIC MAP (
            positionBitNb => positionBitNb,
            position0     => position0
        )
        PORT MAP (
            clock         => clock,
            encoderA      => encoderA,
            reset         => reset,
            position      => position,
            encoderB      => encoderB,
            clearPosition => clearPosition,
            encoderI      => encoderI
        );
    I_pwm : pulseWidthModulator
        GENERIC MAP (
            counterBitNb => pwmBitNb,
            minAmplitude => minAmplitude
        )
        PORT MAP (
            amplitude => amplitude,
            clock     => clock,
            en        => enPWM,
            reset     => reset,
            PWM       => PWM
        );
    I_lcd2 : lcdController
        GENERIC MAP (
            baudRateDivide => 2,
            asciiBitNb     => 7
        )
        PORT MAP (
            reset => reset,
            SI    => SI,
            SCL   => SCL,
            A0    => A0,
            CS1_n => CS1_n,
            RST_n => RST_n,
            clock => clock,
            ascii => character,
            send  => send,
            busy  => busy
        );

    -- Implicit buffered output assignments
    motorOn <= motorOn_internal;

END struct;




LIBRARY ieee;
USE ieee.std_logic_1164.all;

PACKAGE gates IS

--  constant gateDelay: time := 1 ns;
  constant gateDelay: time := 0.1 ns;

END gates;




-- VHDL Entity gates.inverter.symbol
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WE5370)
--          at - 10:36:46 17.11.2016
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY inverter IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      in1  : IN     std_uLogic;
      out1 : OUT    std_uLogic
   );

-- Declarations

END inverter ;





ARCHITECTURE sim OF inverter IS
BEGIN
  out1 <= NOT in1 after delay;
END sim;




-- VHDL Entity sequential.DFF.symbol
--
-- Created:
--          by - francois.corthay.UNKNOWN (WEA20108)
--          at - 13:45:21 28.11.2017
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2009.2 (Build 10)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
-- LIBRARY gates;
  use work.gates.all;

ENTITY DFF IS
   GENERIC( 
      delay : time := gateDelay
   );
   PORT( 
      CLK : IN     std_uLogic;
      CLR : IN     std_uLogic;
      D   : IN     std_uLogic;
      Q   : OUT    std_uLogic
   );

-- Declarations

END DFF ;





ARCHITECTURE sim OF DFF IS
BEGIN

  process(clk, clr)
  begin
    if clr = '1' then
      q <= '0' after delay;
    elsif rising_edge(clk) then
      q <= d after delay;
    end if;
  end process;

END sim;




--
-- VHDL Architecture Board.FPGA_cursor.struct
--
-- Created:
--          by - oliver.gubler.UNKNOWN (WEA20312)
--          at - 13:30:30 14.11.2018
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2018.1 (Build 12)
--
LIBRARY ieee;
  USE ieee.std_logic_1164.all;
  USE ieee.numeric_std.all;
-- LIBRARY gates;
  use work.gates.all;
-- LIBRARY Common;
  use work.CommonLib.all;

-- LIBRARY Cursor;
-- LIBRARY sequential;

ARCHITECTURE struct OF FPGA_cursor IS

    -- Architecture declarations
    constant stepsPerTurn : positive := 500 * 4;
    constant cmPerTurn : real:= 0.175;
    constant position0 : positive := integer(3.5 * real(stepsPerTurn) / cmPerTurn);
    constant position1 : positive := integer(8.0 * real(stepsPerTurn) / cmPerTurn);
    constant position2 : positive := integer(12.0 * real(stepsPerTurn) / cmPerTurn);
    constant pwmBitNb : positive := 8;
    constant slopeShiftBitNb : positive := requiredBitNb(integer(real(stepsPerTurn)/cmPerTurn+0.5)) - pwmBitNb;
    constant testLineNb : positive := 16;

    -- Internal signal declarations
    SIGNAL button4Synch  : std_uLogic;
    SIGNAL encoderA      : std_uLogic;
    SIGNAL encoderASynch : std_uLogic;
    SIGNAL encoderB      : std_uLogic;
    SIGNAL encoderBSynch : std_uLogic;
    SIGNAL encoderI      : std_uLogic;
    SIGNAL encoderISynch : std_uLogic;
    SIGNAL go1           : std_uLogic;
    SIGNAL go1Synch      : std_uLogic;
    SIGNAL go2           : std_uLogic;
    SIGNAL go2Synch      : std_uLogic;
    SIGNAL logic1        : std_uLogic;
    SIGNAL reset         : std_ulogic;
    SIGNAL resetSynch    : std_ulogic;
    SIGNAL resetSynch_n  : std_ulogic;
    SIGNAL restart       : std_uLogic;
    SIGNAL restartSynch  : std_uLogic;
    SIGNAL sensor1       : std_uLogic;
    SIGNAL sensor1Synch  : std_uLogic;
    SIGNAL sensor2       : std_uLogic;
    SIGNAL sensor2Synch  : std_uLogic;
    SIGNAL setPoint      : std_uLogic;
    SIGNAL testOut       : std_uLogic_vector(1 TO testLineNb);


    -- Component Declarations
    COMPONENT cursorCircuit
    GENERIC (
        position0       : positive := 128;
        position1       : positive := 32000;
        position2       : positive := 64000;
        slopeShiftBitNb : positive := 6;
        pwmBitNb        : positive := 8;
        testLineNb      : positive := 16
    );
    PORT (
        button4  : IN     std_uLogic ;
        clock    : IN     std_ulogic ;
        encoderA : IN     std_uLogic ;
        encoderB : IN     std_uLogic ;
        encoderI : IN     std_uLogic ;
        go1      : IN     std_uLogic ;
        go2      : IN     std_uLogic ;
        reset    : IN     std_ulogic ;
        restart  : IN     std_uLogic ;
        sensor1  : IN     std_uLogic ;
        sensor2  : IN     std_uLogic ;
        testMode : IN     std_uLogic ;
        A0       : OUT    std_ulogic ;
        CS1_n    : OUT    std_ulogic ;
        RST_n    : OUT    std_ulogic ;
        SCL      : OUT    std_ulogic ;
        SI       : OUT    std_ulogic ;
        motorOn  : OUT    std_uLogic ;
        side1    : OUT    std_uLogic ;
        side2    : OUT    std_uLogic ;
        testOut  : OUT    std_uLogic_vector (1 TO testLineNb)
    );
    END COMPONENT;
    COMPONENT inverter
    GENERIC (
        delay : time := gateDelay
    );
    PORT (
        in1  : IN     std_uLogic ;
        out1 : OUT    std_uLogic 
    );
    END COMPONENT;
    COMPONENT DFF
    GENERIC (
        delay : time := gateDelay
    );
    PORT (
        CLK : IN     std_uLogic ;
        CLR : IN     std_uLogic ;
        D   : IN     std_uLogic ;
        Q   : OUT    std_uLogic 
    );
    END COMPONENT;

    -- Optional embedded configurations
    -- pragma synthesis_off
--     FOR ALL : DFF USE ENTITY sequential.DFF;
--     FOR ALL : cursorCircuit USE ENTITY Cursor.cursorCircuit;
--     FOR ALL : inverter USE ENTITY gates.inverter;
    -- pragma synthesis_on


BEGIN
    -- Architecture concurrent statements
    -- HDL Embedded Text Block 1 eb1
    logic1 <= '1';

    -- HDL Embedded Text Block 2 eb2
    LED1 <= testOut(16);
    --LED2 <= not testOut(16);
    LED2 <= testOut(15);
    
    LEDs <= testOut(1 to 8);


    -- Instance port mappings.
    I0 : cursorCircuit
        GENERIC MAP (
            position0       => position0,
            position1       => position1,
            position2       => position2,
            slopeShiftBitNb => slopeShiftBitNb,
            pwmBitNb        => pwmBitNb,
            testLineNb      => testLineNb
        )
        PORT MAP (
            button4  => button4Synch,
            clock    => clock,
            encoderA => encoderASynch,
            encoderB => encoderBSynch,
            encoderI => encoderISynch,
            go1      => go1Synch,
            go2      => go2Synch,
            reset    => resetSynch,
            restart  => restartSynch,
            sensor1  => sensor1Synch,
            sensor2  => sensor2Synch,
            testMode => testMode,
            A0       => LCD_A0,
            CS1_n    => LCD_CS1_n,
            RST_n    => LCD_RST_n,
            SCL      => LCD_SCL,
            SI       => LCD_SI,
            motorOn  => motorOn,
            side1    => side1,
            side2    => side2,
            testOut  => testOut
        );
    I1 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => reset_n,
            out1 => reset
        );
    I7 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => resetSynch_n,
            out1 => resetSynch
        );
    I8 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => sensor2_n,
            out1 => sensor2
        );
    I9 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => go2_n,
            out1 => go2
        );
    I10 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => restart_n,
            out1 => restart
        );
    I11 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => button4_n,
            out1 => setPoint
        );
    I12 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => go1_n,
            out1 => go1
        );
    I15 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => sensor1_n,
            out1 => sensor1
        );
    I18 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => encoderB_n,
            out1 => encoderB
        );
    I19 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => encoderA_n,
            out1 => encoderA
        );
    I21 : inverter
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            in1  => encoderI_n,
            out1 => encoderI
        );
    I2 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => go2,
            Q   => go2Synch
        );
    I3 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => setPoint,
            Q   => button4Synch
        );
    I4 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => restart,
            Q   => restartSynch
        );
    I5 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => sensor2,
            Q   => sensor2Synch
        );
    I6 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => reset,
            D   => logic1,
            Q   => resetSynch_n
        );
    I13 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => go1,
            Q   => go1Synch
        );
    I14 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => sensor1,
            Q   => sensor1Synch
        );
    I16 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => encoderB,
            Q   => encoderBSynch
        );
    I17 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => encoderA,
            Q   => encoderASynch
        );
    I20 : DFF
        GENERIC MAP (
            delay => 1 ns
        )
        PORT MAP (
            CLK => clock,
            CLR => resetSynch,
            D   => encoderI,
            Q   => encoderISynch
        );

END struct;




